import os, sys

mcfile = "/usr/lib/opcenter/sendmail/install/sendmail.mc"
cffile = "/etc/mail/sendmail.cf"
bkp_ext = ".bkp"

def backupFile(fname):
    if not os.path.exists(fname):
        print "File does not exist: %s" % fname
        sys.exit(1)
    cmd = "/bin/cp -f %s %s%s" % (fname, fname, bkp_ext)
    if os.system(cmd) == 0:
        print "File backup:"
        print "    %s -> %s%s" % (fname, fname, bkp_ext)

mc_content = file(mcfile).readlines()
line_no = 0
line_no_to_insert = 0
for line in mc_content:
    if "relay_hosts_only" in line:
        print "relay_hosts_only directive found present in %s" % mcfile
        sys.exit(0)
    if "LOCAL_DOMAIN" in line:
        line_no_to_insert = line_no + 1
    if "SMTP_MAILER_FLAGS" in line and line_no_to_insert == 0:
        line_no_to_insert = line_no
    line_no += 1

if line_no_to_insert:
    backupFile(mcfile)
    backupFile(cffile)
    mc_content.insert(line_no_to_insert, "FEATURE(`relay_hosts_only')dnl\n")
    f = file(mcfile, 'w')
    f.writelines(mc_content)
    f.close()
else:
    print "Could not mofify %s" % mcfile
    sys.exit(1)

cmd1 = "/usr/bin/m4 %s > sendmail.cf" % mcfile
cmd2 = "/etc/rc.d/init.d/sendmail restart"

os.system("%s && %s" % (cmd1, cmd2))
print "Applying hotfix is successful."
